# $Revision: 1.23 $, $Date: 2006/12/10 13:23:03 $
#
# Conditional build:
%bcond_without	dist_kernel	# allow non-distribution kernel
%bcond_without	kernel		# don't build kernel modules
%bcond_without	smp		# don't build SMP module
%bcond_without	userspace	# don't build userspace module

%define		netfilter_snap		20040302
%define		iptables_version	1.2.9
%define		_kernelsrcdir		/usr/src/linux-2.4

%define	_rel	1
Summary:	IPP2P - a netfilter extension to identify P2P filesharing traffic
Summary(pl):	IPP2P - rozszerzenie filtra pakietw identyfikujce ruch P2P
Name:		ipp2p24
Version:	0.8.2
Release:	%{_rel}
License:	GPL
Group:		Base/Kernel
Source0:	http://www.ipp2p.org/downloads/ipp2p-%{version}.tar.gz
# Source0-md5:	9dd745830f302d70d0b728013c1d6a0c
URL:		http://www.ipp2p.org/
%{?with_userspace:BuildRequires:	iptables24-devel = %{iptables_version}_%{netfilter_snap}}
%if %{with kernel} && %{with dist_kernel}
BuildRequires:	kernel24-headers
BuildRequires:	kernel24-headers(netfilter) = %{iptables_version}-%{netfilter_snap}
%endif
BuildRequires:	rpmbuild(macros) >= 1.153
BuildRequires:	sed >= 4.0
ExclusiveArch:	%{ix86} sparc sparc64 alpha ppc
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
IPP2P is a netfilter extension to identify P2P filesharing traffic.
The main goal for developing IPP2P was giving the adminstrator a
dynamic tool to filter the traffic in an intelligent way. So it
doesn't aim at prohibiting all P2P traffic but make it possible to
shape this traffic to a given rate. For this purpose IPP2P searchs the
payload of TCP packets for signaling patterns of P2P networks. As
these patterns are not being present in all P2P packets we had to use
some other netfilter extensions in order to get the whole IPP2P
package working as already described. IPP2P works together with
connection tracking and connection marking - in that way you can catch
the bigger part of all P2P packets and limit the bandwidth rate.

%description -l pl
IPP2P to rozszerzenie netfiltra suce do identyfikowania ruchu
zwizanego z dzieleniem plikw P2P. Gwnym celem tworzenia IPP2P jest
udostpnienie administratorowi dynamicznego narzdzia do filtrowania
ruchu w inteligentny sposb. Nie jest nim zablokowanie caego ruchu
P2P, ale umoliwienie ograniczenia tego ruchu do danej przepustowoci.
W tym celu IPP2P przeszukuje zawarto (payload) pakietw TCP pod
ktem wzorcw sygnalizujcych sieci P2P. Jeli tych wzorcw nie ma w
pakietach, musz by uyte inne rozszerzenia netfiltra, aby IPP2P
dziaao zgodnie z opisem. IPP2P wsppracuje ze ledzeniem oraz
znakowaniem pocze - w ten sposb mona wychwyci wiksz cz
pakietw P2P i ograniczy wykorzystanie cza przez nie.

%package -n kernel24-net-ipp2p
Summary:	IPP2P - a netfilter extension to identify P2P filesharing traffic
Summary(pl):	IPP2P - rozszerzenie filtra pakietw identyfikujce ruch P2P
Release:	%{_rel}@%{_kernel_ver_str}
Group:		Base/Kernel
%{?with_dist_kernel:%requires_releq_kernel_up}
Requires(post,postun):	/sbin/depmod
%{?with_dist_kernel:Requires:	kernel(netfilter) = %{iptables_version}-%{netfilter_snap}}

%description -n kernel24-net-ipp2p
IPP2P is a netfilter extension to identify P2P filesharing traffic.
The main goal for developing IPP2P was giving the adminstrator a
dynamic tool to filter the traffic in an intelligent way. So it
doesn't aim at prohibiting all P2P traffic but make it possible to
shape this traffic to a given rate. For this purpose IPP2P searchs the
payload of TCP packets for signaling patterns of P2P networks. As
these patterns are not being present in all P2P packets we had to use
some other netfilter extensions in order to get the whole IPP2P
package working as already described. IPP2P works together with
connection tracking and connection marking - in that way you can catch
the bigger part of all P2P packets and limit the bandwidth rate.

This package contains Linux kernel module.

%description -n kernel24-net-ipp2p -l pl
IPP2P to rozszerzenie netfiltra suce do identyfikowania ruchu
zwizanego z dzieleniem plikw P2P. Gwnym celem tworzenia IPP2P jest
udostpnienie administratorowi dynamicznego narzdzia do filtrowania
ruchu w inteligentny sposb. Nie jest nim zablokowanie caego ruchu
P2P, ale umoliwienie ograniczenia tego ruchu do danej przepustowoci.
W tym celu IPP2P przeszukuje zawarto (payload) pakietw TCP pod
ktem wzorcw sygnalizujcych sieci P2P. Jeli tych wzorcw nie ma w
pakietach, musz by uyte inne rozszerzenia netfiltra, aby IPP2P
dziaao zgodnie z opisem. IPP2P wsppracuje ze ledzeniem oraz
znakowaniem pocze - w ten sposb mona wychwyci wiksz cz
pakietw P2P i ograniczy wykorzystanie cza przez nie.

Ten pakiet zawiera modu jdra Linuksa.

%package -n kernel24-smp-net-ipp2p
Summary:	IPP2P - a netfilter extension to identify P2P filesharing traffic
Summary(pl):	IPP2P - rozszerzenie filtra pakietw identyfikujce ruch P2P
Release:	%{_rel}@%{_kernel_ver_str}
Group:		Base/Kernel
%{?with_dist_kernel:%requires_releq_kernel_smp}
Requires(post,postun):	/sbin/depmod
%{?with_dist_kernel:Requires:	kernel(netfilter) = %{iptables_version}-%{netfilter_snap}}
Provides:	kernel24-net-ipp2p = %{version}-%{_rel}@%{_kernel_ver_str}

%description -n kernel24-smp-net-ipp2p
IPP2P is a netfilter extension to identify P2P filesharing traffic.
The main goal for developing IPP2P was giving the adminstrator a
dynamic tool to filter the traffic in an intelligent way. So it
doesn't aim at prohibiting all P2P traffic but make it possible to
shape this traffic to a given rate. For this purpose IPP2P searchs the
payload of TCP packets for signaling patterns of P2P networks. As
these patterns are not being present in all P2P packets we had to use
some other netfilter extensions in order to get the whole IPP2P
package working as already described. IPP2P works together with
connection tracking and connection marking - in that way you can catch
the bigger part of all P2P packets and limit the bandwidth rate.

This package contains Linux SMP kernel module.

%description -n kernel24-smp-net-ipp2p -l pl
IPP2P to rozszerzenie netfiltra suce do identyfikowania ruchu
zwizanego z dzieleniem plikw P2P. Gwnym celem tworzenia IPP2P jest
udostpnienie administratorowi dynamicznego narzdzia do filtrowania
ruchu w inteligentny sposb. Nie jest nim zablokowanie caego ruchu
P2P, ale umoliwienie ograniczenia tego ruchu do danej przepustowoci.
W tym celu IPP2P przeszukuje zawarto (payload) pakietw TCP pod
ktem wzorcw sygnalizujcych sieci P2P. Jeli tych wzorcw nie ma w
pakietach, musz by uyte inne rozszerzenia netfiltra, aby IPP2P
dziaao zgodnie z opisem. IPP2P wsppracuje ze ledzeniem oraz
znakowaniem pocze - w ten sposb mona wychwyci wiksz cz
pakietw P2P i ograniczy wykorzystanie cza przez nie.

Ten pakiet zawiera modu jdra Linuksa SMP.

%package -n iptables24-ipp2p
Summary:	IPP2P - a netfilter extension to identify P2P filesharing traffic
Summary(pl):	IPP2P - rozszerzenie filtra pakietw identyfikujce ruch P2P
Release:	%{_rel}
Group:		Base/Kernel
Requires:	iptables24 = %{iptables_version}_%{netfilter_snap}
Requires:	kernel24-net-ipp2p = %{version}-%{_rel}@%{_kernel_ver_str}

%description -n iptables24-ipp2p
IPP2P is a netfilter extension to identify P2P filesharing traffic.
The main goal for developing IPP2P was giving the adminstrator a
dynamic tool to filter the traffic in an intelligent way. So it
doesn't aim at prohibiting all P2P traffic but make it possible to
shape this traffic to a given rate. For this purpose IPP2P searchs the
payload of TCP packets for signaling patterns of P2P networks. As
these patterns are not being present in all P2P packets we had to use
some other netfilter extensions in order to get the whole IPP2P
package working as already described. IPP2P works together with
connection tracking and connection marking - in that way you can catch
the bigger part of all P2P packets and limit the bandwidth rate.

This package contains iptables module needed to control IPP2P kernel
module.

%description -n iptables24-ipp2p -l pl
IPP2P to rozszerzenie netfiltra suce do identyfikowania ruchu
zwizanego z dzieleniem plikw P2P. Gwnym celem tworzenia IPP2P jest
udostpnienie administratorowi dynamicznego narzdzia do filtrowania
ruchu w inteligentny sposb. Nie jest nim zablokowanie caego ruchu
P2P, ale umoliwienie ograniczenia tego ruchu do danej przepustowoci.
W tym celu IPP2P przeszukuje zawarto (payload) pakietw TCP pod
ktem wzorcw sygnalizujcych sieci P2P. Jeli tych wzorcw nie ma w
pakietach, musz by uyte inne rozszerzenia netfiltra, aby IPP2P
dziaao zgodnie z opisem. IPP2P wsppracuje ze ledzeniem oraz
znakowaniem pocze - w ten sposb mona wychwyci wiksz cz
pakietw P2P i ograniczy wykorzystanie cza przez nie.

Ten pakiet zawiera modu iptables potrzebny do sterowania moduem
jdra IPP2P.

%prep
%setup -q -n ipp2p-%{version}
sed -i "s:shell iptables:shell %{_sbindir}/iptables:" Makefile

%build
%if %{with userspace}
%{__make} libipt_ipp2p.so \
	IPTABLES_OPTION="-DIPTABLES_VERSION=\\\"%{iptables_version}-%{netfilter_snap}\\\"" \
	IPTABLES_INCLUDE="-I/usr/include/iptables" \
	CFLAGS="%{rpmcflags}" \
	KERNEL_DIR="%{_kernelsrcdir}" \
	KERNEL_SRC="%{_kernelsrcdir}"
%endif

%if %{with kernel}
%if %{with smp}
%{__make} ipt_ipp2p.o \
	CFLAGS="-O3 -Wall -D__KERNEL_SMP=1 -D__SMP__" \
	KERNEL_DIR="%{_kernelsrcdir}" \
	KERNEL_SRC="%{_kernelsrcdir}"
mv ipt_ipp2p.o ipt_ipp2p-smp.o
%endif

%{__make} ipt_ipp2p.o \
	CFLAGS="-O3 -Wall" \
	KERNEL_DIR="%{_kernelsrcdir}" \
	KERNEL_SRC="%{_kernelsrcdir}"
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with userspace}
install -d $RPM_BUILD_ROOT%{_libdir}/iptables24
install libipt_ipp2p.so $RPM_BUILD_ROOT%{_libdir}/iptables24
%endif

%if %{with kernel}
install -d $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}{,smp}/kernel/net/ipv4/netfilter
install ipt_ipp2p.o \
	$RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}/kernel/net/ipv4/netfilter/ipt_ipp2p.o
%if %{with smp} && %{with dist_kernel}
install ipt_ipp2p-smp.o \
	$RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}smp/kernel/net/ipv4/netfilter/ipt_ipp2p.o
%endif
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post -n kernel24-net-ipp2p
%depmod %{_kernel_ver}

%postun -n kernel24-net-ipp2p
%depmod %{_kernel_ver}

%post -n kernel24-smp-net-ipp2p
%depmod %{_kernel_ver}smp

%postun -n kernel24-smp-net-ipp2p
%depmod %{_kernel_ver}smp

%if %{with kernel}
%files -n kernel24-net-ipp2p
%defattr(644,root,root,755)
/lib/modules/%{_kernel_ver}/kernel/net/ipv4/netfilter/*

%if %{with smp} && %{with dist_kernel}
%files -n kernel24-smp-net-ipp2p
%defattr(644,root,root,755)
/lib/modules/%{_kernel_ver}smp/kernel/net/ipv4/netfilter/*
%endif
%endif

%if %{with userspace}
%files -n iptables24-ipp2p
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/iptables24/*.so
%endif

%define	date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: ipp2p24.spec,v $
Revision 1.23  2006/12/10 13:23:03  marcus
- fix build

Revision 1.22  2006/12/03 20:18:36  marcus
- updated to 0.8.2
- please STBR with new 2.4.33

Revision 1.21  2006/09/05 09:45:54  hawk
- release 2

Revision 1.20  2006/04/12 12:15:41  glen
- add kernel epoch, adapterized

Revision 1.19  2006/03/05 11:06:54  gotar
- proper rc versioning scheme

Revision 1.18  2006/01/05 20:52:05  dzeus
- up to 0.8.1_rc1

Revision 1.17  2005/10/22 12:43:00  dzeus
- proper %setup

Revision 1.16  2005/10/21 20:26:55  dzeus
- up to final 0.8.0

Revision 1.15  2005/07/05 08:16:40  gotar
- upgraded to 0.8.0rc3

Revision 1.14  2005/05/21 23:10:07  averne
- rel 2

Revision 1.13  2005/03/18 10:33:07  havner
- rel 2

Revision 1.12  2005/02/23 00:49:40  patrys
- proper R: (iptables -> iptables24)

Revision 1.11  2005/02/11 16:51:09  marcus
- proper BR

Revision 1.10  2005/01/02 15:52:58  gotar
- updated to 0.7.1

Revision 1.9  2004/12/27 23:55:57  gotar
- upgraded to 0.7

Revision 1.8  2004/09/16 23:17:57  havner
- rel 3

Revision 1.7  2004/09/16 22:43:31  gotar
- added ExclusiveArch as there's no other archs with kernel24 in PLD

Revision 1.6  2004/09/14 18:38:29  havner
- rel 2

Revision 1.5  2004/09/14 17:58:36  gotar
- fixed some stupid oversights

Revision 1.4  2004/09/04 09:26:10  gotar
- renamed libdir to iptables24

Revision 1.3  2004/09/01 16:11:10  adamg
- kill pld.org.pl leftovers

Revision 1.2  2004/08/31 15:52:46  snurf
- typos / formatting / etc.

Revision 1.1  2004/07/29 17:57:30  gotar
- branched from ipp2p.spec, added strict reqs

Revision 1.21  2004/07/29 13:35:45  havner
- rel 3 for rebuild

Revision 1.20  2004/07/29 13:06:10  averne
- rel2 for rebuild with proper iptables-devel

Revision 1.19  2004/07/22 19:15:07  qboosh
- Name changed to ipp2p, kernel-net-ipp2p.spec renamed to ipp2p.spec
- up module to subpackage, fixed smp depmods

Revision 1.18  2004/07/13 16:53:15  pluto
- BR(kernel-module-build) fixed.

Revision 1.17  2004/07/08 21:18:18  pluto
- updated to 0.6.
  (--gnu for better matching of Shareaza
   --edk new eMule and Kademlia patterns).

Revision 1.16  2004/07/03 21:05:17  pluto
- netfilter version = 1.2.11

Revision 1.15  2004/06/29 22:34:25  gotar
- s/filtru/filtra/

Revision 1.14  2004/05/30 18:07:42  pluto
- 2.6.7+ complaint.
- release 2.

Revision 1.13  2004/04/29 18:19:02  pluto
- netfilter version updated.

Revision 1.12  2004/04/08 11:35:36  pluto
- 2.6.5 fixes.

Revision 1.11  2004/03/16 09:51:59  qboosh
- removed empty post/postun for iptables module

Revision 1.10  2004/03/15 00:05:37  pluto
- updated to 0.5c.
  new option: --soul for SoulSeek (DROP only).
  extension: --kazaa also matches iMesh packets now.

  note that SoulSeek opens a new TCP connection for every download.
  We can not recognize this connection so marking does not work.
  But we can detect CONNECT and TRANSFER REQUEST packets so a DROP
  rule will make Soulseek stop working.

Revision 1.9  2004/03/14 18:40:53  pluto
- fixed INCPATH.

Revision 1.8  2004/03/14 17:34:37  pluto
- s/%%{_kernel_ver_str}/%%{_kernel_ver}/

Revision 1.7  2004/03/11 12:51:57  pluto
- fixed build with non-dist kernel.
- release 2.

Revision 1.6  2004/03/11 10:47:55  qboosh
- fixed build with dist_kernel once again

Revision 1.5  2004/03/10 18:58:58  pluto
- removed redudant symlinks {asm,autoconf.h}.
- multiconf build (up{,smp} xor nondist).

Revision 1.4  2004/03/10 16:19:25  qboosh
- fixed autoconf.h issue with distro kernel
- still waiting for pluto to fix both UP+SMP build

Revision 1.3  2004/03/04 19:08:55  qboosh
- merged fixes from HEAD and LINUX_2_6, cleanups, pl, kernel/userspace bconds

Revision 1.2  2004/03/03 22:39:46  ankry
- some typos, md5, fixed Group

Revision 1.1.2.8  2004/03/04 02:51:15  pluto
- drivers/net -> net/ipv4/netfilter

Revision 1.1.2.7  2004/03/04 01:51:05  pluto
- fixed cflags.

Revision 1.1.2.6  2004/03/03 22:37:57  pluto
- %%desc, NFY...

Revision 1.1.2.5  2004/03/03 21:57:31  pluto
- fixed %%build, %%install, %%files

Revision 1.1.2.4  2004/03/03 09:13:25  cieciwa
- fixed %%build, %%install, %%files,
- %%description and %%summary not updated.

Revision 1.1.2.3  2004/03/03 08:32:26  cieciwa
- updated

Revision 1.1.2.2  2004/03/03 08:22:54  cieciwa
- updated

Revision 1.1.2.1  2004/03/03 08:17:31  cieciwa
- working on

Revision 1.1  2004/03/03 07:37:21  cieciwa
- initial
